--- configure.in.old	2009-04-06 16:41:41.000000000 +0000
+++ configure.in	2009-04-06 16:41:41.000000000 +0000
@@ -2442,6 +2442,7 @@ fi
 dnl ===================================================================
 dnl system stl sanity tests
 dnl ===================================================================
+HAVE_GCC_VISIBILITY_BROKEN=
 if test "$USE_SYSTEM_STL" = "YES"; then
    AC_MSG_CHECKING([if hash_map will be in __gnu_cxx namespace])
    AC_LANG_PUSH([C++])
@@ -2481,9 +2482,9 @@ using namespace std;
       gccvisok=no)
       AC_MSG_RESULT([$gccvisok])
       if test "$gccvisok" = "no"; then
-         AC_MSG_WARN([Your gcc is not -fvisibility-inlines-hidden safe. Disabling visibility])
-         echo "Your gcc is not -fvisibility-inlines-hidden safe. Disabling visibility" >> warn
-         unset HAVE_GCC_VISIBILITY_FEATURE
+         AC_MSG_WARN([Your gcc is not -fvisibility-inlines-hidden safe, disabling that.])
+         echo "Your gcc is not -fvisibility-inlines-hidden safe, disabling that." >> warn
+         HAVE_GCC_VISIBILITY_BROKEN="TRUE"
       fi
 
       LDFLAGS=$sharedlink_ldflags_save
@@ -2523,6 +2524,7 @@ _ACEOF
 fi
 
 AC_SUBST(HAVE_GCC_VISIBILITY_FEATURE)
+AC_SUBST(HAVE_GCC_VISIBILITY_BROKEN)
 
 dnl ===================================================================
 dnl allocator
--- set_soenv.in.old	2009-04-06 16:41:41.000000000 +0000
+++ set_soenv.in	2009-04-06 16:41:41.000000000 +0000
@@ -1874,6 +1874,8 @@ ToFile( "JAVAHOME",          $JAVAHOME,
 ToFile( "CC",                $CC,                "e" );
 ToFile( "HAVE_GCC_VISIBILITY_FEATURE",
 		"@HAVE_GCC_VISIBILITY_FEATURE@", "e" );
+ToFile( "HAVE_GCC_VISIBILITY_BROKEN",
+		"@HAVE_GCC_VISIBILITY_BROKEN@", "e" );
 ToFile( "HAVE_LD_HASH_STYLE","@HAVE_LD_HASH_STYLE@","e" );
 ToFile( "CXX",               $CXX,               "e" );
 ToFile( "MINGWCXX",          "@MINGWCXX@",       "e" );
Index: unxlng.mk
===================================================================
--- solenv/inc/unxlng.mk	(Revision 276754)
+++ solenv/inc/unxlng.mk	(Arbeitskopie)
@@ -92,7 +92,7 @@
 
 # -fpermissive should be removed as soon as possible
 CFLAGSCXX= -pipe $(ARCH_FLAGS)
-.IF "$(HAVE_GCC_VISIBILITY_FEATURE)" == "TRUE"
+.IF "$(HAVE_GCC_VISIBILITY_FEATURE)" == "TRUE" && "$(HAVE_GCC_VISIBILITY_BROKEN)" != "TRUE"
 CFLAGSCXX += -fvisibility-inlines-hidden
 .ENDIF # "$(HAVE_GCC_VISIBILITY_FEATURE)" == "TRUE"
 
